<?php
include('db/connection.php');
date_default_timezone_set('Asia/Kolkata');

$rand = rand(1111, 9999);

$invsql = "SELECT * FROM mas_investment";
$invRes = $con->query($invsql);
$invRow = $invRes->fetch_assoc();

$jsonData = json_encode($invRow);

$divsql = "SELECT * FROM mas_division";
$divRes = $con->query($divsql);
$divRow = $divRes->fetch_assoc();

$jsonDatadiv = json_encode($divRow);

$typeSql = "SELECT * FROM mas_slot_type";
$typeRes = $con->query($typeSql);

?>
<?php include 'layouts/header.php'; ?>
<?php include 'layouts/topbar.php'; ?>
<?php include 'layouts/sidebar.php'; ?>

<!-- [ Header ] end --><!-- [ Main Content ] start -->
<section class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item"><a href="index.php">Home</a></li>
                            <li class="breadcrumb-item"><a href="javascript: void(0)">Add Contests</a></li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <h5>Add Contest</h5>
                    </div>
                    <form action="save_slot.php" id="amountForm" method="POST" enctype="multipart/form-data">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-sm-4">
                                    <label class="form-label">Spin Wheel ID:</label>
                                    <input type="text" class="form-control form-control-sm" name="slot_id" id="slot_id" value="<?= $rand;?>" readonly placeholder="Enter Name" required>
                                </div>
                                <div class="col-sm-4">
                                    <label class="form-label">Spin Wheel type:</label>
                                    <select name="type" id="type" class="form-select form-select-sm" onchange="gettype(event)">
                                        <option value="">Select Contest type</option>
                                        <?php
                                        while($typerow = $typeRes->fetch_assoc()){
                                            ?>
                                            <option value="<?= $typerow['id']; ?>"><?= $typerow['type']; ?></option>
                                            <?php
                                        }
                                        ?>
                                    </select>
                                </div>
                                <div class="col-sm-4">
                                    <label class="form-label">Spin Wheel image:</label>
                                    <input type="file" class="form-control form-control-sm" name="slot_img" id="slot_img" accept="image/png, image/gif, image/jpeg, image/jpg" required>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-sm-4">
                                    <label class="form-label">Spin Wheel Name:</label>
                                    <input type="text" class="form-control form-control-sm" name="slot_name" id="slot_name" placeholder="Enter Name" required>
                                </div>
                                <div class="col-sm-4">
                                    <label class="form-label">Slot Count:</label>
                                    <input type="number" class="form-control form-control-sm" name="divisionvalue" id="divisionvalue" placeholder="Enter Total Slot" onkeyup="divisionCount(event)" required>
                                </div>
                                <div class="col-sm-4">
                                    <label class="form-label">Maximum Entry:</label>
                                    <input type="hidden" name="allowedentry" id = "allowedentry">
                                    <input type="number" class="form-control form-control-sm" name="totalentry" id="totalentry" placeholder="Enter maximum entry" onkeyup="entryCount(event)" required>
                                </div>
                            </div>
                            <hr>
                            <h5>Validate date and time</h5>
                            <hr>
                            <div class="row">
                                <div class="col-sm-4">
                                    <label class="form-label">From date and time:</label>
                                    <input type="datetime-local" class="form-control form-control-sm" name="fromdatetime" id="fromdatetime" required>
                                </div>
                                <div class="col-sm-4">
                                    <label class="form-label">To date and time:</label>
                                    <input type="datetime-local" class="form-control form-control-sm" name="todatetime" id="todatetime" required>
                                </div>
                                <div class="col-sm-4">
                                    <label class="form-label">Spin end Date time:</label>
                                    <input type="datetime-local" class="form-control form-control-sm" name="spinenddatetime" id="spinenddatetime" required>
                                </div>
                            </div>
                            <hr>
                            <table class="table">
                                <thead>
                                    <th>S No</th>
                                    <th>Slot Name</th>
                                    <th>Slot Image</th>
                                    <th>Entry</th>
                                    <th>Minimum Amount</th>
                                    <th>Maximum Amount</th>
                                </thead>
                                <tbody id="slotid"></tbody>
                            </table>
                            <!-- <div id="slotid"></div> -->
                        </div>
                        <div class="card-footer text-end">
                            <button type="submit" name="submit" id="submit" class="btn btn-primary me-2" >Submit</button>
                            <a href="mas_slot.php" class="btn btn-secondary">Back</a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</section>

<?php include 'layouts/footer.php'; ?>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/sweetalert/dist/sweetalert.min.js"></script>
<script>

        var divRow = <?php echo $jsonDatadiv; ?>;
        var divdata = divRow.max_division;


    document.getElementById('amountForm').addEventListener('submit', function(event) {
        const divisionvalue = document.getElementById('divisionvalue');
        const totalentry = document.getElementById('totalentry');

        const division = parseFloat(divisionvalue.value);
        const entry = parseFloat(totalentry.value);
        
        let isValid = true;

        if(divdata <= division){
            swal('Division count value '+divdata+' number only allowed');
            isValid = false;
        }

        if (isNaN(division) || division <= 0) {
            swal('Division value must be greater than 0.');
            isValid = false;
        }

        if (isNaN(entry) || entry <= 0) {
            swal('Maximum entry must be greater than 0.');
            isValid = false;
        }

        if (!isValid) {
            event.preventDefault();
        }
    });

    var invRow = <?php echo $jsonData; ?>;

    var minimum_amount = invRow.min_inv_amt;
    var maximum_amount = invRow.max_inv_amt;

    function mix(event){
        var getminvalue = event.target.value;

        let isValid1 = true;

        if (isNaN(getminvalue) || getminvalue <= minimum_amount) {
            swal('Minimum Amount '+ minimum_amount +' greater then value only allowed');
            isValid1 = false;
        }
        if (!isValid1) {
            event.preventDefault();
        }
    }

    function maxi(event1){
        var getmaxvalue = event1.target.value;

        let isValid2 = true;

        if (isNaN(getmaxvalue) || getmaxvalue >= maximum_amount) {
            swal('Maximum Amount '+ maximum_amount +' less then value only allowed');
            isValid2 = false;
        }
        if (!isValid2) {
            event.preventDefault();
        }
    }

function calculateSum() {
    var sum = 0;
    var elements = document.querySelectorAll('.qty1');
    elements.forEach(function(element) {
        sum += parseFloat(element.value) || 0;
    });

    const totalentry = document.getElementById('totalentry');
    const entry = parseFloat(totalentry.value);

    if(entry < sum){
        swal('Maximum entry value '+entry+' only allowed');
        elements.forEach(function(element) {
            element.value = '';
        });
    }
}



    function divisionCount(event){
        var value = event.target.value;

        var divdataInt = parseInt(divdata, 10);

        if(value > divdataInt){
            swal('Slot count value '+divdata+' only allowed');
        }

        if(value > 0){

            var container = document.getElementById('slotid');
            container.innerHTML = '';
            for (let i = 1; i <= value; i++) {
            
                var html = '';
                html += '<tr>';
                html += '<td><input type="number" class="form-control form-control-sm"value="'+i+'" readonly /></td>';
                html += '<td><input type="text" name="divisionname[]" class="form-control form-control-sm" placeholder="slot name" /></td>';
                html += '<td><input type="file" name="divisionimg[]" class="form-control form-control-sm" accept="image/png, image/gif, image/jpeg, image/jpg" /></td>';
                html += '<td><input type="number" name="entry[]" class="form-control form-control-sm qty1" placeholder="entry" onkeyup="calculateSum(event)" /></td>';
                html += '<td><input type="number" name="minamt[]" class="form-control form-control-sm" placeholder="Minimum Amount" onkeyup="mix(event)" /></td>';
                html += '<td><input type="number" name="maxamt[]" class="form-control form-control-sm" placeholder="Maximum Amount" onkeyup="maxi(event)" /></td>';
                html += '</tr>';

                container.innerHTML += html;
            }

        }else{
            swal("Slot value please enter the greater then 0");
        }
    }

    function gettype(id){
        var id = id.target.value;

        const totalentry = document.getElementById('totalentry');
        const entry = parseFloat(totalentry.value);

        $.ajax({
            type: "POST",
            url: "ajax_search.php",
            data: {'id': id},
            success: function(result){
                document.getElementById('allowedentry').value = result;
            }
        });
    }

    function entryCount(val){
        var value = val.target.value;

        const allowedentry = document.getElementById('allowedentry');
        const allow_entry = parseFloat(allowedentry.value);

        if(allow_entry < value){
            swal('Maximum entry value '+allow_entry+' number only allowed');
            document.getElementById('totalentry').value = '';
        }
    }
</script>